/// <reference types="node" />
import { BlockAssetJSON, BlockAssets } from './block_assets';
import { BlockHeader, BlockHeaderJSON } from './block_header';
import { Transaction, TransactionJSON } from './transaction';
export interface BlockJSON {
    header: BlockHeaderJSON;
    transactions: TransactionJSON[];
    assets: BlockAssetJSON[];
}
export declare class Block {
    readonly header: BlockHeader;
    readonly transactions: Transaction[];
    readonly assets: BlockAssets;
    constructor(header: BlockHeader, transactions: Transaction[], assets: BlockAssets);
    static fromBytes(value: Buffer): Block;
    static fromJSON(value: BlockJSON): Block;
    getBytes(): Buffer;
    toJSON(): BlockJSON;
    validate(): void;
    validateGenesis(): void;
}
