"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toSMTKey = exports.copyBuffer = void 0;
const lisk_cryptography_1 = require("@liskhq/lisk-cryptography");
const constants_1 = require("../constants");
const copyBuffer = (value) => {
    const copiedValue = Buffer.alloc(value.length);
    value.copy(copiedValue);
    return copiedValue;
};
exports.copyBuffer = copyBuffer;
const toSMTKey = (value) => Buffer.concat([
    value.slice(1, constants_1.SMT_PREFIX_SIZE + 1),
    lisk_cryptography_1.utils.hash(value.slice(constants_1.SMT_PREFIX_SIZE + 1)),
]);
exports.toSMTKey = toSMTKey;
//# sourceMappingURL=utils.js.map