export declare const configSchema: {
    $id: string;
    type: string;
    properties: {
        port: {
            type: string;
            minimum: number;
            maximum: number;
        };
        host: {
            type: string;
            format: string;
        };
        encryptedPrivateKey: {
            type: string;
            description: string;
        };
        tokenID: {
            type: string;
            format: string;
            description: string;
        };
        applicationUrl: {
            type: string;
            format: string;
            description: string;
        };
        fee: {
            type: string;
            description: string;
        };
        amount: {
            type: string;
            description: string;
        };
        tokenPrefix: {
            type: string;
            description: string;
        };
        logoURL: {
            type: string;
            format: string;
            description: string;
        };
        captchaSecretkey: {
            type: string;
            description: string;
        };
        captchaSitekey: {
            type: string;
            description: string;
        };
    };
    required: string[];
    default: {
        port: number;
        host: string;
        applicationUrl: string;
        fee: string;
        amount: string;
        tokenPrefix: string;
    };
};
export declare const fundParamsSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        address: {
            type: string;
            format: string;
        };
        token: {
            type: string;
        };
    };
};
export declare const authorizeParamsSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        password: {
            type: string;
        };
        enable: {
            type: string;
        };
    };
};
