import { BasePlugin, BasePluginEndpoint, PluginEndpointContext, db as liskDB } from 'lisk-sdk';
import { Forger } from './types';
interface Staker {
    readonly address: string;
    readonly username: string;
    readonly totalStakeReceived: string;
    readonly stakers: {
        readonly address: string;
        readonly amount: string;
    }[];
}
interface ForgerInfo extends Forger {
    readonly username: string;
    readonly totalReceivedFees: string;
    readonly totalReceivedRewards: string;
    readonly totalProducedBlocks: number;
    readonly totalStakeReceived: string;
    readonly consecutiveMissedBlocks: number;
}
export declare class Endpoint extends BasePluginEndpoint {
    private _client;
    private _db;
    init(db: liskDB.Database, apiClient: BasePlugin['apiClient']): void;
    getStakers(_context: PluginEndpointContext): Promise<Staker[]>;
    getForgingInfo(_context: PluginEndpointContext): Promise<ForgerInfo[]>;
}
export {};
