export declare const forgerInfoSchema: {
    $id: string;
    type: string;
    properties: {
        totalProducedBlocks: {
            dataType: string;
            fieldNumber: number;
        };
        totalReceivedFees: {
            dataType: string;
            fieldNumber: number;
        };
        totalReceivedRewards: {
            dataType: string;
            fieldNumber: number;
        };
        stakeReceived: {
            type: string;
            fieldNumber: number;
            items: {
                type: string;
                required: string[];
                properties: {
                    address: {
                        dataType: string;
                        fieldNumber: number;
                    };
                    amount: {
                        dataType: string;
                        fieldNumber: number;
                    };
                };
            };
        };
    };
    required: string[];
};
export declare const forgerSyncSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        syncUptoHeight: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare const posStakeParamsSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        stakes: {
            type: string;
            minItems: number;
            maxItems: number;
            items: {
                type: string;
                required: string[];
                properties: {
                    validatorAddress: {
                        dataType: string;
                        fieldNumber: number;
                        minLength: number;
                        maxLength: number;
                    };
                    amount: {
                        dataType: string;
                        fieldNumber: number;
                    };
                };
            };
            fieldNumber: number;
        };
    };
};
