/// <reference types="node" />
import { chain, db as liskDB } from 'lisk-sdk';
declare const BlockHeader: typeof chain.BlockHeader;
export declare const blockHeadersSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        blockHeaders: {
            type: string;
            fieldNumber: number;
            items: {
                dataType: string;
            };
        };
    };
};
export interface BlockHeaderAsset {
    readonly seedReveal: Buffer;
    readonly maxHeightPreviouslyForged: number;
    readonly maxHeightPrevoted: number;
}
interface BlockHeaders {
    readonly blockHeaders: Buffer[];
}
export declare const getDBInstance: (dataPath: string, dbName?: string) => Promise<liskDB.Database>;
export declare const getBlockHeaders: (db: liskDB.Database, dbKeyBlockHeader: Buffer) => Promise<BlockHeaders>;
export declare const saveBlockHeaders: (db: liskDB.Database, headerBytes: Buffer) => Promise<boolean>;
export declare const getContradictingBlockHeader: (db: liskDB.Database, blockHeader: chain.BlockHeader) => Promise<chain.BlockHeader | undefined>;
export declare const clearBlockHeaders: (db: liskDB.Database, currentHeight: number) => Promise<void>;
export {};
