/// <reference types="node" />
export type Transaction = TransactionObject & TransactionFunctions;
export interface TransactionObject {
    readonly id: Buffer;
    readonly nonce: bigint;
    readonly fee: bigint;
    readonly senderPublicKey: Buffer;
    receivedAt?: Date;
    feePriority?: bigint;
}
export interface TransactionFunctions {
    getBytes: () => Buffer;
}
export declare enum Status {
    FAIL = 0,
    OK = 1
}
export declare enum TransactionStatus {
    INVALID = -1,
    UNPROCESSABLE = 0,
    PROCESSABLE = 1
}
