"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StatusCommand = void 0;
const base_ipc_client_1 = require("../base_ipc_client");
class StatusCommand extends base_ipc_client_1.BaseIPCClientCommand {
    async run() {
        if (!this._client) {
            this.error('APIClient is not initialized.');
        }
        const info = await this._client.invoke('generator_getStatus');
        this.printJSON({ info });
    }
}
StatusCommand.description = 'Get forging information for the locally running node.';
StatusCommand.examples = ['generator:status', 'generator:status --data-path ./sample --pretty'];
StatusCommand.flags = {
    ...base_ipc_client_1.BaseIPCClientCommand.flags,
};
exports.StatusCommand = StatusCommand;
//# sourceMappingURL=status.js.map