import { Application, PartialApplicationConfig } from 'lisk-framework';
import { Command } from '@oclif/core';
export declare abstract class BaseGenesisBlockCommand extends Command {
    static description: string;
    static examples: string[];
    static flags: {
        network: import("@oclif/core/lib/interfaces").OptionFlag<string>;
        config: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        output: import("@oclif/core/lib/interfaces").OptionFlag<string>;
        'assets-file': import("@oclif/core/lib/interfaces").OptionFlag<string>;
        'export-json': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        height: import("@oclif/core/lib/interfaces").OptionFlag<number | undefined>;
        timestamp: import("@oclif/core/lib/interfaces").OptionFlag<number | undefined>;
        'previous-block-id': import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
    };
    run(): Promise<void>;
    abstract getApplication(config: PartialApplicationConfig): Application;
    abstract getApplicationConfigDir(): string;
}
