import { Command } from '@oclif/core';
import { Application, PartialApplicationConfig } from 'lisk-framework';
export declare abstract class StartCommand extends Command {
    static description: string;
    static examples: string[];
    static flags: {
        'data-path': import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        network: import("@oclif/core/lib/interfaces").OptionFlag<string>;
        config: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        'overwrite-config': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        port: import("@oclif/core/lib/interfaces").OptionFlag<number | undefined>;
        'api-ipc': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        'api-ws': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        'api-http': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        'api-port': import("@oclif/core/lib/interfaces").OptionFlag<number | undefined>;
        'api-host': import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        log: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        'seed-peers': import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
    };
    run(): Promise<void>;
    abstract getApplication(config: PartialApplicationConfig): Promise<Application>;
    abstract getApplicationConfigDir(): string;
}
