"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_generator_1 = require("./base_generator");
class CommandGenerator extends base_generator_1.default {
    constructor(args, opts) {
        super(args, opts);
        this._liskAssetArgs = {
            moduleName: opts.moduleName,
            commandName: opts.commandName,
        };
    }
    async initializing() {
        await this._loadAndValidateTemplate();
    }
    writing() {
        this.log('Generating asset skeleton.');
        this.composeWith({
            Generator: this._liskTemplate.generators.command,
            path: this._liskTemplatePath,
        }, this._liskAssetArgs);
    }
    end() {
        this.log('\n\n');
        this.log('Your asset is created and ready to use.\n');
    }
}
exports.default = CommandGenerator;
//# sourceMappingURL=command_generator.js.map