/// <reference types="node" />
import * as liskApiClient from '@liskhq/lisk-api-client';
import { ModuleMetadataJSON, RegisteredSchema } from 'lisk-framework';
import { Schema } from '../types';
export declare const getParamsSchema: (metadata: ModuleMetadataJSON[], module: string, command: string) => Schema;
export declare const decodeTransaction: (schema: RegisteredSchema, metadata: ModuleMetadataJSON[], transactionHexStr: string) => {
    params: Record<string, unknown>;
    id: string;
    module: string;
    command: string;
    senderPublicKey: string;
    nonce: string;
    fee: string;
    signatures: readonly string[];
};
export declare const encodeTransaction: (schema: RegisteredSchema, metadata: ModuleMetadataJSON[], transaction: Record<string, unknown>, apiClient?: liskApiClient.APIClient) => Buffer;
export declare const encodeTransactionJSON: (schema: RegisteredSchema, metadata: ModuleMetadataJSON[], transaction: Record<string, unknown>, apiClient?: liskApiClient.APIClient) => Buffer;
export declare const transactionToJSON: (schema: RegisteredSchema, metadata: ModuleMetadataJSON[], transaction: Record<string, unknown>, apiClient?: liskApiClient.APIClient) => Record<string, unknown>;
export declare const getApiClient: (appDataPath: string | undefined, name: string) => Promise<liskApiClient.APIClient>;
