/// <reference types="node" />
import { Chain } from '@liskhq/lisk-chain';
import { Database } from '@liskhq/lisk-db';
import { BFTMethod } from '../../bft';
import { Network } from '../../network';
export interface UnsignedCertificate {
    readonly blockID: Buffer;
    readonly height: number;
    readonly timestamp: number;
    readonly stateRoot: Buffer;
    readonly validatorsHash: Buffer;
}
export interface Certificate extends UnsignedCertificate {
    aggregationBits: Buffer;
    signature: Buffer;
}
export interface SingleCommit {
    readonly blockID: Buffer;
    readonly height: number;
    readonly validatorAddress: Buffer;
    readonly certificateSignature: Buffer;
}
export interface CommitPoolConfig {
    readonly network: Network;
    readonly blockTime: number;
    readonly minCertifyHeight: number;
    readonly bftMethod: BFTMethod;
    readonly chain: Chain;
    readonly db: Database;
}
export interface ValidatorInfo {
    readonly address: Buffer;
    readonly blsPublicKey: Buffer;
    readonly blsSecretKey: Buffer;
}
