/// <reference types="node" />
export interface RPCBlocksByIdData {
    readonly blockId: Buffer;
}
export declare const getBlocksFromIdRequestSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        blockId: {
            fieldNumber: number;
            dataType: string;
            minLength: number;
            maxLength: number;
        };
    };
};
export declare const getBlocksFromIdResponseSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        blocks: {
            type: string;
            fieldNumber: number;
            items: {
                dataType: string;
            };
        };
    };
};
export declare const getHighestCommonBlockRequestSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        ids: {
            type: string;
            fieldNumber: number;
            minItems: number;
            items: {
                dataType: string;
                minLength: number;
                maxLength: number;
            };
        };
    };
};
export interface RPCHighestCommonBlockRequest {
    readonly ids: Buffer[];
}
export declare const getHighestCommonBlockResponseSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        id: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
    };
};
export interface RPCHighestCommonBlockResponse {
    readonly id: Buffer;
}
export interface EventPostBlockData {
    readonly block: Buffer;
}
export declare const postBlockEventSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        block: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
