/// <reference types="node" />
import { Block } from '@liskhq/lisk-chain';
export interface BlockExecutor {
    validate: (block: Block) => void;
    verify: (block: Block) => Promise<void>;
    getFinalizedHeight: () => number;
    executeValidated: (block: Block, options?: {
        skipBroadcast?: boolean;
        removeFromTempTable?: boolean;
    }) => Promise<Block>;
    deleteLastBlock: (options?: {
        saveTempBlock?: boolean;
    }) => Promise<void>;
    getCurrentValidators(): Promise<{
        address: Buffer;
        bftWeight: bigint;
    }[]>;
    getSlotNumber(timestamp: number): number;
}
