import { Database } from '@liskhq/lisk-db';
import { BFTMethod } from '../bft';
import { BFTHeights } from '../bft/types';
import { RequestContext } from '../rpc/rpc_server';
interface EndpointArgs {
    bftMethod: BFTMethod;
    blockchainDB: Database;
}
export interface BFTValidatorJSON {
    address: string;
    bftWeight: string;
    blsKey: string;
}
interface BFTParametersJSON {
    prevoteThreshold: string;
    precommitThreshold: string;
    certificateThreshold: string;
    validators: BFTValidatorJSON[];
    validatorsHash: string;
}
export declare class ConsensusEndpoint {
    [key: string]: unknown;
    private readonly _bftMethod;
    private readonly _blockchainDB;
    constructor(args: EndpointArgs);
    getBFTParameters(ctx: RequestContext): Promise<BFTParametersJSON>;
    getBFTParametersActiveValidators(ctx: RequestContext): Promise<BFTParametersJSON>;
    getBFTHeights(_ctx: RequestContext): Promise<BFTHeights>;
}
export {};
