export declare const blockSchemaV2: {
    $id: string;
    type: string;
    properties: {
        header: {
            dataType: string;
            fieldNumber: number;
        };
        payload: {
            type: string;
            items: {
                dataType: string;
            };
            fieldNumber: number;
        };
    };
    required: string[];
};
export declare const blockHeaderSchemaV2: {
    $id: string;
    type: string;
    properties: {
        version: {
            dataType: string;
            fieldNumber: number;
        };
        timestamp: {
            dataType: string;
            fieldNumber: number;
        };
        height: {
            dataType: string;
            fieldNumber: number;
        };
        previousBlockID: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
        transactionRoot: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
        generatorPublicKey: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
        reward: {
            dataType: string;
            fieldNumber: number;
        };
        asset: {
            dataType: string;
            fieldNumber: number;
        };
        signature: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
    };
    required: string[];
};
export declare const transactionSchemaV2: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        moduleID: {
            dataType: string;
            fieldNumber: number;
            minimum: number;
        };
        assetID: {
            dataType: string;
            fieldNumber: number;
        };
        nonce: {
            dataType: string;
            fieldNumber: number;
        };
        fee: {
            dataType: string;
            fieldNumber: number;
        };
        senderPublicKey: {
            dataType: string;
            fieldNumber: number;
            minLength: number;
            maxLength: number;
        };
        asset: {
            dataType: string;
            fieldNumber: number;
        };
        signatures: {
            type: string;
            items: {
                dataType: string;
            };
            fieldNumber: number;
        };
    };
};
export declare const legacyChainBracketInfoSchema: {
    $id: string;
    type: string;
    properties: {
        startHeight: {
            dataType: string;
            fieldNumber: number;
        };
        snapshotBlockHeight: {
            dataType: string;
            fieldNumber: number;
        };
        lastBlockHeight: {
            dataType: string;
            fieldNumber: number;
        };
    };
    required: string[];
};
export declare const getLegacyBlocksFromIdRequestSchema: {
    $id: string;
    title: string;
    type: string;
    required: string[];
    properties: {
        blockID: {
            fieldNumber: number;
            dataType: string;
            minLength: number;
            maxLength: number;
        };
        snapshotBlockID: {
            fieldNumber: number;
            dataType: string;
            minLength: number;
            maxLength: number;
        };
    };
};
