import { Histogram } from 'prom-client';
export declare class Metrics {
    private _enabled;
    private readonly _registry;
    constructor(enabled?: boolean);
    enable(): void;
    disable(): void;
    enabled(): boolean;
    counter(name: string): {
        inc: (_num?: number | undefined) => void;
        reset: () => void;
    };
    gauge(name: string): {
        inc: (_num?: number | undefined) => void;
        dec: (_num?: number | undefined) => void;
        set: (_num: number) => void;
    };
    histogram(name: string, buckets?: number[]): {
        observe: (_num: number) => void;
        startTimer: () => () => void;
        reset: () => void;
    } | Histogram<string>;
    report(inJSON?: boolean): Promise<string | import("prom-client").MetricObjectWithValues<import("prom-client").MetricValue<string>>[]>;
}
export declare const defaultMetrics: Metrics;
