/// <reference types="node" />
import { Block } from '@liskhq/lisk-chain';
import { Schema } from '@liskhq/lisk-codec';
import { Logger } from './logger';
import { StateMachine } from './state_machine';
export interface GenesisBlockGenerateInput {
    chainID: Buffer;
    height?: number;
    timestamp?: number;
    previousBlockID?: Buffer;
    assets: {
        schema: Schema;
        module: string;
        data: Record<string, unknown>;
    }[];
}
export declare const generateGenesisBlock: (stateMachine: StateMachine, logger: Logger, input: GenesisBlockGenerateInput) => Promise<Block>;
