export declare const createDirIfNotExist: (filePath: string) => void;
interface LoggerInput {
    readonly logLevel: string;
    readonly name: string;
}
export interface Logger {
    readonly trace: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly debug: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly info: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly warn: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly error: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly fatal: (data?: Record<string, unknown> | unknown, message?: string) => void;
    readonly level: () => number;
}
export declare const createLogger: ({ logLevel, name }: LoggerInput) => Logger;
export {};
