"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MainchainInteroperabilityMethod = void 0;
const base_interoperability_method_1 = require("../base_interoperability_method");
const chain_account_1 = require("../stores/chain_account");
class MainchainInteroperabilityMethod extends base_interoperability_method_1.BaseInteroperabilityMethod {
    async isChannelActive(context, chainID, timestamp) {
        const ownChainAccount = await this.getOwnChainAccount(context);
        if (chainID.equals(ownChainAccount.chainID)) {
            return false;
        }
        const chainAccount = await this.stores.get(chain_account_1.ChainAccountStore).get(context, chainID);
        return ((await this.internalMethod.isLive(context, chainID, timestamp)) &&
            chainAccount.status === 1);
    }
}
exports.MainchainInteroperabilityMethod = MainchainInteroperabilityMethod;
//# sourceMappingURL=method.js.map