"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SidechainInteroperabilityEndpoint = void 0;
const lisk_validator_1 = require("@liskhq/lisk-validator");
const base_interoperability_endpoint_1 = require("../base_interoperability_endpoint");
const schemas_1 = require("../schemas");
const utils_1 = require("../utils");
class SidechainInteroperabilityEndpoint extends base_interoperability_endpoint_1.BaseInteroperabilityEndpoint {
    getMainchainID(context) {
        lisk_validator_1.validator.validate(schemas_1.isChainIDAvailableRequestSchema, context.params);
        const chainID = Buffer.from(context.params.chainID, 'hex');
        return { mainchainID: (0, utils_1.getMainchainID)(chainID).toString('hex') };
    }
}
exports.SidechainInteroperabilityEndpoint = SidechainInteroperabilityEndpoint;
//# sourceMappingURL=endpoint.js.map