"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OutboxRootStore = exports.outboxRootSchema = void 0;
const base_store_1 = require("../../base_store");
const constants_1 = require("../constants");
exports.outboxRootSchema = {
    $id: '/modules/interoperability/outbox',
    type: 'object',
    required: ['root'],
    properties: {
        root: {
            dataType: 'bytes',
            minLength: constants_1.HASH_LENGTH,
            maxLength: constants_1.HASH_LENGTH,
            fieldNumber: 1,
        },
    },
};
class OutboxRootStore extends base_store_1.BaseStore {
    constructor() {
        super(...arguments);
        this.schema = exports.outboxRootSchema;
    }
    get storePrefix() {
        return constants_1.STORE_PREFIX;
    }
}
exports.OutboxRootStore = OutboxRootStore;
//# sourceMappingURL=outbox_root.js.map