import { CommandVerifyContext, VerificationResult, CommandExecuteContext } from '../../../state_machine';
import { BaseCommand } from '../../base_command';
import { ChangeCommissionParams } from '../types';
export declare class ChangeCommissionCommand extends BaseCommand {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            newCommission: {
                dataType: string;
                fieldNumber: number;
                maximum: number;
            };
        };
    };
    private _commissionIncreasePeriod;
    private _maxCommissionIncreaseRate;
    init(args: {
        commissionIncreasePeriod: number;
        maxCommissionIncreaseRate: number;
    }): void;
    verify(context: CommandVerifyContext<ChangeCommissionParams>): Promise<VerificationResult>;
    execute(context: CommandExecuteContext<ChangeCommissionParams>): Promise<void>;
}
