import { CommandVerifyContext, VerificationResult, CommandExecuteContext } from '../../../state_machine';
import { BaseCommand } from '../../base_command';
import { UpdateGeneratorKeyParams, ValidatorsMethod } from '../types';
export declare class UpdateGeneratorKeyCommand extends BaseCommand {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            generatorKey: {
                dataType: string;
                fieldNumber: number;
                minLength: number;
                maxLength: number;
            };
        };
    };
    private _validatorsMethod;
    addDependencies(validatorsMethod: ValidatorsMethod): void;
    verify(context: CommandVerifyContext<UpdateGeneratorKeyParams>): Promise<VerificationResult>;
    execute(context: CommandExecuteContext<UpdateGeneratorKeyParams>): Promise<void>;
}
