/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
export interface RewardsAssignedEventData {
    stakerAddress: Buffer;
    validatorAddress: Buffer;
    tokenID: Buffer;
    amount: bigint;
}
export declare const rewardsAssignedEventParams: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        stakerAddress: {
            dataType: string;
            format: string;
            fieldNumber: number;
        };
        validatorAddress: {
            dataType: string;
            format: string;
            fieldNumber: number;
        };
        tokenID: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        amount: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class RewardsAssignedEvent extends BaseEvent<RewardsAssignedEventData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            stakerAddress: {
                dataType: string;
                format: string;
                fieldNumber: number;
            };
            validatorAddress: {
                dataType: string;
                format: string;
                fieldNumber: number;
            };
            tokenID: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            amount: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, data: RewardsAssignedEventData): void;
}
