/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
export interface RegisterValidatorEventData {
    address: Buffer;
    name: string;
}
export declare const validatorRegisteredDataSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        address: {
            dataType: string;
            fieldNumber: number;
            format: string;
        };
        name: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class ValidatorRegisteredEvent extends BaseEvent<RegisterValidatorEventData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            address: {
                dataType: string;
                fieldNumber: number;
                format: string;
            };
            name: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, data: RegisterValidatorEventData): void;
}
