"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidatorRegisteredEvent = exports.validatorRegisteredDataSchema = void 0;
const base_event_1 = require("../../base_event");
exports.validatorRegisteredDataSchema = {
    $id: '/pos/events/registerValidatorData',
    type: 'object',
    required: ['address', 'name'],
    properties: {
        address: {
            dataType: 'bytes',
            fieldNumber: 1,
            format: 'lisk32',
        },
        name: {
            dataType: 'string',
            fieldNumber: 2,
        },
    },
};
class ValidatorRegisteredEvent extends base_event_1.BaseEvent {
    constructor() {
        super(...arguments);
        this.schema = exports.validatorRegisteredDataSchema;
    }
    log(ctx, data) {
        this.add(ctx, data, [data.address]);
    }
}
exports.ValidatorRegisteredEvent = ValidatorRegisteredEvent;
//# sourceMappingURL=validator_registered.js.map