"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenesisDataStore = exports.genesisDataStoreSchema = void 0;
const base_store_1 = require("../../base_store");
exports.genesisDataStoreSchema = {
    $id: '/pos/store/genesis',
    type: 'object',
    required: ['height', 'initRounds', 'initValidators'],
    properties: {
        height: {
            dataType: 'uint32',
            fieldNumber: 1,
        },
        initRounds: {
            dataType: 'uint32',
            fieldNumber: 2,
        },
        initValidators: {
            type: 'array',
            fieldNumber: 3,
            items: {
                dataType: 'bytes',
                format: 'lisk32',
            },
        },
    },
};
class GenesisDataStore extends base_store_1.BaseStore {
    constructor() {
        super(...arguments);
        this.schema = exports.genesisDataStoreSchema;
    }
}
exports.GenesisDataStore = GenesisDataStore;
//# sourceMappingURL=genesis.js.map