/// <reference types="node" />
import { BaseStore } from '../../base_store';
export interface SnapshotStoreData {
    validatorWeightSnapshot: {
        address: Buffer;
        weight: bigint;
    }[];
}
export declare const snapshotStoreSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        validatorWeightSnapshot: {
            type: string;
            fieldNumber: number;
            items: {
                type: string;
                required: string[];
                properties: {
                    address: {
                        dataType: string;
                        fieldNumber: number;
                        format: string;
                    };
                    weight: {
                        dataType: string;
                        fieldNumber: number;
                    };
                };
            };
        };
    };
};
export declare class SnapshotStore extends BaseStore<SnapshotStoreData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            validatorWeightSnapshot: {
                type: string;
                fieldNumber: number;
                items: {
                    type: string;
                    required: string[];
                    properties: {
                        address: {
                            dataType: string;
                            fieldNumber: number;
                            format: string;
                        };
                        weight: {
                            dataType: string;
                            fieldNumber: number;
                        };
                    };
                };
            };
        };
    };
}
