/// <reference types="node" />
import { BaseOffchainStore } from '../../base_offchain_store';
export interface HashOnion {
    count: number;
    distance: number;
    hashes: Buffer[];
}
export declare const hashOnionSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        count: {
            dataType: string;
            fieldNumber: number;
        };
        distance: {
            dataType: string;
            fieldNumber: number;
        };
        hashes: {
            type: string;
            fieldNumber: number;
            items: {
                dataType: string;
            };
        };
    };
};
export declare class HashOnionStore extends BaseOffchainStore<HashOnion> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            count: {
                dataType: string;
                fieldNumber: number;
            };
            distance: {
                dataType: string;
                fieldNumber: number;
            };
            hashes: {
                type: string;
                fieldNumber: number;
                items: {
                    dataType: string;
                };
            };
        };
    };
}
