export declare const configSchema: {
    $id: string;
    type: string;
    properties: {
        tokenID: {
            type: string;
            format: string;
            minLength: number;
            maxLength: number;
        };
        offset: {
            type: string;
            minimum: number;
        };
        distance: {
            type: string;
            minimum: number;
        };
        brackets: {
            type: string;
            items: {
                type: string;
                format: string;
            };
        };
    };
    required: string[];
};
export declare const heightSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        height: {
            type: string;
            format: string;
        };
    };
};
export declare const getDefaultRewardAtHeightRequestSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        height: {
            type: string;
            format: string;
        };
    };
};
export declare const getAnnualInflationRequestSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        height: {
            type: string;
            format: string;
        };
    };
};
export declare const getDefaultRewardAtHeightResponseSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        reward: {
            type: string;
            format: string;
        };
    };
};
export declare const getAnnualInflationResponseSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        tokenID: {
            type: string;
            format: string;
        };
        rate: {
            type: string;
            format: string;
            minLength: number;
            maxLength: number;
        };
    };
};
export declare const getRewardTokenIDResponseSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        tokenID: {
            type: string;
            format: string;
            minLength: number;
            maxLength: number;
        };
    };
};
