/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
import { TokenEventResult, TokenErrorEventResult } from '../constants';
export interface BeforeCCMForwardingEventData {
    ccmID: Buffer;
    messageFeeTokenID: Buffer;
}
export declare const beforeCCMForwardingEventSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        ccmID: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        messageFeeTokenID: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        result: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class BeforeCCMForwardingEvent extends BaseEvent<BeforeCCMForwardingEventData & {
    result: TokenEventResult;
}> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            ccmID: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            messageFeeTokenID: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            result: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, sendingChainID: Buffer, receivingChainID: Buffer, data: BeforeCCMForwardingEventData): void;
    error(ctx: EventQueuer, sendingChainID: Buffer, receivingChainID: Buffer, data: BeforeCCMForwardingEventData, result: TokenErrorEventResult): void;
}
