/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
import { TokenEventResult, TokenErrorEventResult } from '../constants';
export interface InitializeTokenEventData {
    tokenID: Buffer;
}
export declare const initializeTokenEventSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        tokenID: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        result: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class InitializeTokenEvent extends BaseEvent<InitializeTokenEventData & {
    result: TokenEventResult;
}> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            tokenID: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            result: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, data: InitializeTokenEventData): void;
    error(ctx: EventQueuer, data: InitializeTokenEventData, result: TokenErrorEventResult): void;
}
