"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MintEvent = exports.mintEventSchema = void 0;
const base_event_1 = require("../../base_event");
const constants_1 = require("../constants");
exports.mintEventSchema = {
    $id: '/token/events/mint',
    type: 'object',
    required: ['address', 'tokenID', 'amount', 'result'],
    properties: {
        address: {
            dataType: 'bytes',
            format: 'lisk32',
            fieldNumber: 1,
        },
        tokenID: {
            dataType: 'bytes',
            minLength: constants_1.TOKEN_ID_LENGTH,
            maxLength: constants_1.TOKEN_ID_LENGTH,
            fieldNumber: 2,
        },
        amount: {
            dataType: 'uint64',
            fieldNumber: 3,
        },
        result: {
            dataType: 'uint32',
            fieldNumber: 4,
        },
    },
};
class MintEvent extends base_event_1.BaseEvent {
    constructor() {
        super(...arguments);
        this.schema = exports.mintEventSchema;
    }
    log(ctx, data) {
        this.add(ctx, { ...data, result: 0 }, [data.address]);
    }
    error(ctx, data, result) {
        this.add(ctx, { ...data, result }, [data.address], true);
    }
}
exports.MintEvent = MintEvent;
//# sourceMappingURL=mint.js.map