/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
export interface TokenIDSupportRemovedEventData {
    tokenID: Buffer;
}
export declare const tokenIDSupportRemovedEventSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        tokenID: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
    };
};
export declare class TokenIDSupportRemovedEvent extends BaseEvent<TokenIDSupportRemovedEventData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            tokenID: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, tokenID: Buffer): void;
}
