/// <reference types="node" />
import { MethodContext } from '../../state_machine';
import { BaseMethod } from '../base_method';
import { FeeMethod, ModuleConfig } from './types';
export declare class InternalMethod extends BaseMethod {
    private _feeMethod;
    private _config;
    init(config: ModuleConfig): void;
    addDependencies(feeMethod: FeeMethod): void;
    initializeUserAccount(methodContext: MethodContext, address: Buffer, tokenID: Buffer): Promise<void>;
    initializeEscrowAccount(methodContext: MethodContext, chainID: Buffer, tokenID: Buffer): Promise<void>;
    transfer(methodContext: MethodContext, senderAddress: Buffer, recipientAddress: Buffer, tokenID: Buffer, amount: bigint): Promise<void>;
}
