/// <reference types="node" />
import { BaseStore, ImmutableStoreGetter } from '../../base_store';
export interface SupplyStoreData {
    totalSupply: bigint;
}
export declare const supplyStoreSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        totalSupply: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class SupplyStore extends BaseStore<SupplyStoreData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            totalSupply: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    getAll(context: ImmutableStoreGetter): Promise<{
        key: Buffer;
        value: SupplyStoreData;
    }[]>;
}
