/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
import { KeyRegResult } from '../constants';
export interface BLSKeyRegData {
    blsKey: Buffer;
    proofOfPossession: Buffer;
    result: KeyRegResult;
}
export declare const blsKeyRegDataSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        blsKey: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        proofOfPossession: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        result: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class BlsKeyRegistrationEvent extends BaseEvent<BLSKeyRegData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            blsKey: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            proofOfPossession: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            result: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, validatorAddress: Buffer, data: BLSKeyRegData): void;
}
