/// <reference types="node" />
import { BaseEvent, EventQueuer } from '../../base_event';
import { KeyRegResult } from '../constants';
export interface GeneratorKeyRegData {
    generatorKey: Buffer;
    result: KeyRegResult;
}
export declare const generatorKeyRegDataSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        generatorKey: {
            dataType: string;
            minLength: number;
            maxLength: number;
            fieldNumber: number;
        };
        result: {
            dataType: string;
            fieldNumber: number;
        };
    };
};
export declare class GeneratorKeyRegistrationEvent extends BaseEvent<GeneratorKeyRegData> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            generatorKey: {
                dataType: string;
                minLength: number;
                maxLength: number;
                fieldNumber: number;
            };
            result: {
                dataType: string;
                fieldNumber: number;
            };
        };
    };
    log(ctx: EventQueuer, validatorAddress: Buffer, data: GeneratorKeyRegData): void;
}
