export interface ValidateBLSKeyRequest {
    proofOfPossession: string;
    blsKey: string;
}
export declare const validateBLSKeyRequestSchema: {
    $id: string;
    title: string;
    type: string;
    properties: {
        proofOfPossession: {
            type: string;
            format: string;
            minLength: number;
            maxLength: number;
        };
        blsKey: {
            type: string;
            format: string;
            minLength: number;
            maxLength: number;
        };
    };
    required: string[];
};
export declare const validateBLSKeyResponseSchema: {
    $id: string;
    title: string;
    type: string;
    properties: {
        valid: {
            type: string;
        };
    };
    required: string[];
};
export interface GetValidatorRequest {
    address: string;
}
export declare const getValidatorRequestSchema: {
    $id: string;
    title: string;
    type: string;
    properties: {
        address: {
            dataType: string;
            format: string;
        };
    };
    required: string[];
};
export declare const getValidatorResponseSchema: {
    $id: string;
    title: string;
    type: string;
    properties: {
        generatorKey: {
            type: string;
            format: string;
        };
        blsKey: {
            type: string;
            format: string;
        };
    };
    required: string[];
};
