import { Validator } from '../../../state_machine/types';
import { BaseStore } from '../../base_store';
export declare const validatorSchema: {
    type: string;
    required: string[];
    properties: {
        address: {
            fieldNumber: number;
            dataType: string;
            format: string;
        };
        bftWeight: {
            fieldNumber: number;
            dataType: string;
        };
        generatorKey: {
            fieldNumber: number;
            dataType: string;
        };
        blsKey: {
            fieldNumber: number;
            dataType: string;
        };
    };
};
export declare const validatorsParamsSchema: {
    $id: string;
    type: string;
    required: string[];
    properties: {
        preCommitThreshold: {
            fieldNumber: number;
            dataType: string;
        };
        certificateThreshold: {
            fieldNumber: number;
            dataType: string;
        };
        validators: {
            fieldNumber: number;
            type: string;
            items: {
                type: string;
                required: string[];
                properties: {
                    address: {
                        fieldNumber: number;
                        dataType: string;
                        format: string;
                    };
                    bftWeight: {
                        fieldNumber: number;
                        dataType: string;
                    };
                    generatorKey: {
                        fieldNumber: number;
                        dataType: string;
                    };
                    blsKey: {
                        fieldNumber: number;
                        dataType: string;
                    };
                };
            };
        };
    };
};
export interface ValidatorsParams {
    preCommitThreshold: bigint;
    certificateThreshold: bigint;
    validators: Validator[];
}
export declare class ValidatorsParamsStore extends BaseStore<ValidatorsParams> {
    schema: {
        $id: string;
        type: string;
        required: string[];
        properties: {
            preCommitThreshold: {
                fieldNumber: number;
                dataType: string;
            };
            certificateThreshold: {
                fieldNumber: number;
                dataType: string;
            };
            validators: {
                fieldNumber: number;
                type: string;
                items: {
                    type: string;
                    required: string[];
                    properties: {
                        address: {
                            fieldNumber: number;
                            dataType: string;
                            format: string;
                        };
                        bftWeight: {
                            fieldNumber: number;
                            dataType: string;
                        };
                        generatorKey: {
                            fieldNumber: number;
                            dataType: string;
                        };
                        blsKey: {
                            fieldNumber: number;
                            dataType: string;
                        };
                    };
                };
            };
        };
    };
}
