/// <reference types="node" />
import { BlockAssets, BlockHeader, StateStore } from '@liskhq/lisk-chain';
import { Logger } from '../logger';
import { PrefixedStateReadWriter } from './prefixed_state_read_writer';
import { InsertAssetContext } from './types';
interface GenerationContextArgs {
    logger: Logger;
    stateStore: PrefixedStateReadWriter;
    contextStore: Map<string, unknown>;
    header: BlockHeader;
    generatorStore: StateStore;
    chainID: Buffer;
    finalizedHeight: number;
}
export declare class GenerationContext {
    private readonly _logger;
    private readonly _chainID;
    private readonly _stateStore;
    private readonly _contextStore;
    private readonly _header;
    private readonly _assets;
    private readonly _generatorStore;
    private readonly _finalizedHeight;
    constructor(args: GenerationContextArgs);
    get blockHeader(): BlockHeader;
    getInsertAssetContext(): InsertAssetContext;
    get assets(): BlockAssets;
}
export {};
