"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.blockAssetsJSON = void 0;
const lisk_cryptography_1 = require("@liskhq/lisk-cryptography");
const schemas_1 = require("../../modules/pos/schemas");
const token_1 = require("../../modules/token");
const accounts = require("./keys_fixture.json");
exports.blockAssetsJSON = [
    {
        module: 'token',
        data: {
            userSubstore: accounts.keys
                .map(account => ({
                address: account.address,
                tokenID: '0000000000000000',
                availableBalance: '10000000000000',
                lockedBalances: [],
            }))
                .sort((a, b) => lisk_cryptography_1.address
                .getAddressFromLisk32Address(a.address)
                .compare(lisk_cryptography_1.address.getAddressFromLisk32Address(b.address))),
            supplySubstore: [
                {
                    tokenID: '0000000000000000',
                    totalSupply: (BigInt(accounts.keys.length) * BigInt('10000000000000')).toString(),
                },
            ],
            escrowSubstore: [],
            supportedTokensSubstore: [],
        },
        schema: token_1.genesisTokenStoreSchema,
    },
    {
        module: 'pos',
        data: {
            validators: accounts.keys.map((account, i) => ({
                address: account.address,
                name: `genesis_${i}`,
                blsKey: account.plain.blsKey,
                proofOfPossession: account.plain.blsProofOfPossession,
                generatorKey: account.plain.generatorKey,
                lastGeneratedHeight: 0,
                isBanned: false,
                reportMisbehaviorHeights: [],
                consecutiveMissedBlocks: 0,
                commission: 0,
                lastCommissionIncreaseHeight: 0,
                sharingCoefficients: [],
            })),
            stakers: [],
            genesisData: {
                initRounds: 3,
                initValidators: accounts.keys.slice(0, 101).map(account => account.address),
            },
        },
        schema: schemas_1.genesisStoreSchema,
    },
];
//# sourceMappingURL=genesis-asset.js.map